<script>
  export let route
  export let title

  import getGroupAuth from '../utils/getGroupAuth'

  import Form from '../components/Form'
  import Error from '../components/Error'

  import groups from '../stores/groups'
  import homeworks from '../stores/homeworks'
  import offline from '../stores/offline'

  import { getGroup } from '../api/groups'
  import { createHomework, updateHomework } from '../api/homeworks'

  $: groupId = parseInt(route.matches[1])
  $: homeworkId = route.matches[2] && parseInt(route.matches[2])
  $: group = $groups[groupId]
  $: homeworkId
    ? ($title = group ? `Editar tarea en ${group.name}` : 'Editar tarea')
    : ($title = group ? `Crear tarea en ${group.name}` : 'Crear tarea')
  $: homework = homeworkId && $homeworks[homeworkId]

  let auth
  function getInfo() {
    return getGroupAuth(groupId).then(_auth => {
      auth = _auth
      if (!group || !homework) return getGroup(auth.id, auth.secret)
    })
  }
  $: infoPromise = getInfo(groupId, $offline)

  function action({ text, deadline: deadline_date }) {
    if (deadline_date.length < 1) deadline_date = null
    return (homeworkId
      ? updateHomework(
          {
            id: homeworkId,
            text,
            deadline_date,
          },
          auth.secret,
        )
      : createHomework({ text, deadline_date }, auth)
    ).then(() => {
      location.hash = `#/groups/${groupId}`
    })
  }

  $: formValues = {
    text: {
      type: 'textarea',
      label: 'Descripción',
      trim: true,
      props: {
        placeholder:
          'Ejemplo: \nMatemática: prueba. Temas:\n * tema 1\n * tema 2',
        rows: 5,
        required: true,
        value: homework && homework.text,
      },
    },
    deadline: {
      type: 'date',
      label: 'Fecha de entrega',
      props: { required: false, value: homework && homework.deadline_date },
    },
    submit: {
      type: 'submit',
      label: homeworkId ? 'Editar tarea' : 'Crear tarea!',
    },
  }
</script>

{#await infoPromise}
  <p class="p-2 text-center">Cargando grupo...</p>
{:then}
  <Form values={formValues} {action} />
{:catch error}
  <div class="max-w-xl mx-auto">
    <Error className="m-2" {error} />
    <button
      class="btn btn-outlined block mx-auto"
      on:click={e => (location.hash = `#/groups/${groupId}`)}
      href={`#/groups/${groupId}`}>
      Volver atrás
    </button>
  </div>
{/await}
